ClienteMvcApi/Models/DataDto.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace ClienteMvcApi.Models
{
    public class DataDto
    {
        public List<RegionDto> data;
        public ProvinceDto dataProvince;
        public TotalReportDto dataTotalReport;

    }
}

ClienteMvcApi/Models/ErrorViewModel.cs
using System;

namespace ClienteMvcApi.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

ClienteMvcApi/Models/ProvinceDto.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace ClienteMvcApi.Models
{
    public class ProvinceDto
    {
        public string iso { get; set; }
        public string name { get; set; }
        public string province { get; set; }
        public string lat { get; set; }
        public string @long { get; set; }
    }
}

ClienteMvcApi/Models/RegionDto.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace ClienteMvcApi.Models
{
    public class RegionDto
    {
        public string iso { get; set; }
        public string name { get; set; }
    }
}

ClienteMvcApi/Models/ReportDataDto.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace ClienteMvcApi.Models
{
    public class ReportDataDto
    {
        public List<ReportDto> data;
    }
}

ClienteMvcApi/Models/ReportDto.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace ClienteMvcApi.Models
{
    public class ReportDto
    {
        public DateTime date { get; set; }
        public int confirmed { get; set; }
        public int deaths { get; set; }
        public int recovered { get; set; }
        public int confirmed_diff { get; set; }
        public int deaths_diff { get; set; }
        public int recovered_diff { get; set; }
        public DateTime last_update { get; set; }
        public int active { get; set; }
        public int active_diff { get; set; }
        public decimal fatality_rate { get; set; }
    }
}

ClienteMvcApi/Models/TotalReportDto.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace ClienteMvcApi.Models
{
    public class TotalReportDto
    {
        public DateTime date { get; set; }
        public DateTime last_update { get; set; }
        public int confirmed { get; set; }
        public int confirmed_diff { get; set; }
        public int deaths { get; set; }
        public int deaths_diff { get; set; }
        public int recovered { get; set; }        
        public int recovered_diff { get; set; }        
        public int active { get; set; }
        public int active_diff { get; set; }
        public decimal fatality_rate { get; set; }
    }
}

ClienteMvcApi/Controllers/HomeController.cs
using ClienteMvcApi.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;

namespace ClienteMvcApi.Controllers
{
    public class HomeController : Controller
    {
        
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }
        
        public IActionResult Index()
        {
            return View();
        }

        
        public IActionResult Privacy()
        {
            return View();
        }

        
        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
        
    }
}

ClienteMvcApi/Controllers/RegionsController.cs
using ClienteMvcApi.Models;
using ClienteMvcApi.Services;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;

namespace ClienteMvcApi.Controllers
{
    public class RegionsController : Controller
    {

        IRegionRepositoryGUI _regionRepository;
        IReportRepostoryGUI _reportRepository;

        
        public RegionsController(IRegionRepositoryGUI regionRepository, IReportRepostoryGUI reportRepository)
        {
            _regionRepository = regionRepository;
            _reportRepository = reportRepository;
        }

        public async Task<IActionResult> IndexAsync()
        {
            var regions = await _regionRepository.GetRegionsAsync();
            foreach (var region in regions.Take(5))
            {
                var report = await _reportRepository.GetReportByParamAsync(region.iso);
            }

            ViewBag.Regions = regions;

            return View("Index", new List<RegionDto>());
        }

        
        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
        
    }
}

ClienteMvcApi/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

ClienteMvcApi/Views/Regions/Index.cshtml
@model IEnumerable<ClienteMvcApi.Models.RegionDto>
@{ Layout = "_Layout"; ViewBag.Title = "Regiones";}

<h3>Top 10 COVID Cases</h3>
<h3>@ViewBag.StatusCode</h3>

<form method="post" #DropngForm="ngForm" novalidate (ngSubmit)="onSubmit()">
    <div class="form-group">
        @*<label for="id">Id:</label>*@ @*filtrar por id*@

        <div class="card">
            <div class="card-body">
                <div class="input-group-text">
 
                    <div class="col-auto my-1">
                        <label class="mr-sm-2" for="inlineFormCustomSelect"></label>
                        <select class="custom-select form-control mr-sm-2" id="inlineFormCustomSelect" #refRegions="ngModel">
                            <option selected>Regions...</option>
                            @foreach (var region in ViewBag.Regions)
                            {
                                <option value="@region.iso">
                                    @region.iso
                                </option>
                            }

                        </select>
                    </div>


                    <div class="col-auto my-1">
                        @*<button type="submit" class="btn btn-sm btn-primary">Report</button>*@
                        <a asp-action="GetRegionsAsync" class="btn btn-sm btn-primary">Report</a>
                    </div>

                    <div class="btn-group" role="group" aria-label="Basic example">
                        <button type="button" class="btn btn-sm btn-primary">XML</button>
                        <button type="button" class="btn btn-sm btn-primary">JSON</button>
                        <button type="button" class="btn btn-sm btn-primary">CSV</button>
                    </div>

                </div>

            </div>
        </div>


    </div>
</form>


<div class="card">
    <div class="card-body" >
        <table class="table table-borderless table-hover">
            <thead>
                <tr>
                    <th>REGION</th>
                    <th>CASES</th>
                    <th>DEATHS</th>
                </tr>
            </thead>
            <tbody>
                @foreach (var r in Model)
                {
                    <tr>
                        <td>@r.iso</td>
                        <td>@r.name</td>
                        <td>@r.name</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>


<div class="card">
    <div class="card-body">
        <table class="table table-borderless table-hover">
            <thead>
                <tr>
                    <th>PROVINCE</th>
                    <th>CASES</th>
                    <th>DEATHS</th>
                </tr>
            </thead>
            <tbody>
                @foreach (var r in Model)
                {
                    <tr>
                        <td>@r.iso</td>
                        <td>@r.name</td>
                        <td>@r.name</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>

ClienteMvcApi/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - ClienteMvcApi</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Regions" asp-action="Index">ClienteMvcApi</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Regions" asp-action="Index">Regions</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Regions" asp-action="Privacy">Privacy</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2021 - ClienteMvcApi - <a asp-area="" asp-controller="Regions" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>